var GameState = {
    differentCount: 0,
    score: 0,
    currentLevel: null,
    background: null,
    differents: null,
    images: null,
    ciekawostka: null,
    differentsHandleOrginal: null,
    differentsHandle: null,
    mainGroup: null,
    differentStyle: null,
    differentText: null,
    layout: null,
    info: { group: null, show: true },
    endLevelShow: false,
    circleGroup: null,
    endLevelButtons: { clicked: false, enable: true },
    endLevelGroup: null,
    endLevel: {
        gratulationText: null,
        endLevelAgain: null,
        endLevelNext: null,
    },
    create: function() {
        var level;

        switch (this.currentLevel) {
            case 1:
                level = new Level1;
                break;
            case 2:
                level = new Level2;
                break;
            case 3:
                level = new Level3;
                break;
            case 4:
                level = new Level4;
                break;
            case 5:
                level = new Level5;
                break;
            case 6:
                level = new Level6;
                break;
            case 7:
                level = new Level7;
                break;
            case 8:
                level = new Level8;
                break;
        }

        this.background = game.add.group();
        var background = game.add.group();
        background.create(0, 0, level.background);

        this.ciekawostka = level.curiosity;
        this.differentCount = level.differentHandle.length;
        this.differentStyle = level.different;
        this.info.show = true;
        this.score = 0;

        this.images = game.add.group();
        this.differents = game.add.group();
        this.mainGroup = game.add.group();
        this.differentsHandle = game.add.group();
        this.differentsHandleOrginal = game.add.group();
        this.circleGroup = game.add.group();
        this.info.group = game.add.group();
        this.info.group.x = game.world.centerX - 289;
        this.info.group.y = game.world.centerY - 165;

        this.mainGroup.add(this.images);
        this.mainGroup.add(this.differents);
        this.mainGroup.add(this.differentsHandle);
        this.mainGroup.add(this.differentsHandleOrginal);

        this.mainGroup.x = (this.game.width * 0.5) - (level.imagesSize.w + level.imagesMargin.x * 0.5);
        this.mainGroup.y = (this.game.height * 0.5) - (level.imagesSize.h + level.imagesMargin.y) * 0.5;

        this.differents.x = level.imagesSize.w + level.imagesMargin.x;
        this.images.create(0, 0, level.images.image);
        this.images.create(this.differents.x, 0, level.images.imageOrginal);
        GameState.ciekawostkaAnimation();
        level.differentHandle.forEach(function(value) {
            GameState.createDifferents(value, level);
        });

        this.infoImage = this.info.group.create(0, 0, level.info);

        this.infoImage.inputEnabled = true;
        this.infoImage.input.useHandCursor = true;
        this.infoImage.input.start(0, true);
        this.infoImage.events.onInputDown.add(function() {
            game.add.tween(GameState.info.group).to({ alpha: 0 }, 200, Phaser.Easing.Linear.None, true)
                .onComplete.add(function() {
                    GameState.info.show = false;
                    GameState.info.group.destroy();
                });
        });

        this.layout = game.add.graphics();
        this.layout.beginFill(0xFFFFFF, 1);
        this.layout.drawRect(0, 0, this.game.width, this.game.height);

        game.add.tween(this.layout).to({ alpha: 0 }, 400, Phaser.Easing.Linear.None, true);

        GameState.menu = game.add.image(game.world.centerX + game.world.centerX * 0.5 + 81, game.world.centerY - game.world.centerY * 0.5 - 117, 'wyjscieDoMenu2');
        GameState.menu.scale.setTo(0.5, 0.5);
        GameState.menu.alpha = 0;
        GameState.powrotDoMenu = game.add.group();
        GameState.powrotDoMenu = game.add.button(game.world.centerX + game.world.centerX * 0.5 + 160, game.world.centerY - game.world.centerY * 0.5 - 125, 'wyjscieDoMenu1', this.powrotMenu, this, 2, 1, 0);
        GameState.powrotDoMenu.inputEnabled = true;
        GameState.powrotDoMenu.input.useHandCursor = true;
        GameState.powrotDoMenu.onInputOver.add(this.over, this);
        GameState.powrotDoMenu.onInputOut.add(this.out, this);
        GameState.powrotDoMenu.anchor.setTo(0.5, 0, 5);
        GameState.powrotDoMenu.scale.setTo(0.5, 0.5);
    },

    over: function() {

        if (GameState.powrotDoMenu.onInputOver) {
            GameState.menu.alpha = 1;
        }

    },
    out: function() {

        if (GameState.powrotDoMenu.onInputOver) {
            GameState.menu.alpha = 0;
        }

    },
    powrotMenu: function() {
        MenuState.clickedEnable = true;
        game.state.start('MenuState');
    },
    ciekawostkaAnimation: function() {
        var ciekawostka = game.add.sprite(game.world.centerX, game.world.centerY - 30, GameState.ciekawostka);
        ciekawostka.scale.setTo(0.0, 0.0);
        ciekawostka.anchor.x = ciekawostka.anchor.y = 0.5;
        game.add.tween(ciekawostka.scale).to({ x: 1, y: 1 }, 380, Phaser.Easing.Linear.None, true).onComplete.add(function() {
            ciekawostka.inputEnabled = true;
            ciekawostka.input.useHandCursor = true;
            ciekawostka.input.start(0, true);
            ciekawostka.events.onInputDown.add(function() {
                game.add.tween(ciekawostka.scale).to({ x: 1.1, y: 1.1 }, 100, Phaser.Easing.Linear.None, true).onComplete.add(function() {
                    game.add.tween(ciekawostka.scale).to({ x: 0, y: 0 }, 250, Phaser.Easing.Linear.None, true).onComplete.add(function() {
                        ciekawostka.destroy();
                    });
                });
                ciekawostka.inputEnabled = false;
            });
        });
    },
    createDifferents: function(index, level) {
        this.handle = this.differentsHandle.create(index.x, index.y, index.image);
        this.handle.inputEnabled = true;
        this.handle.input.start(0, true);
        this.handle.alpha = 0;
        this.handle.color = index.color;
        this.handle.events.onInputDown.add(this.click);


        this.handleOrginal = this.differentsHandleOrginal.create(index.x + level.imagesSize.w + level.imagesMargin.x, index.y, index.image);

        this.handleOrginal.inputEnabled = true;
        this.handleOrginal.input.start(0, true);
        this.handleOrginal.alpha = 0;
        this.handleOrginal.color = index.color;
        this.handleOrginal.events.onInputDown.add(this.click);
    },

    click: function(item) {

        var circle = game.add.graphics(0, 0);

        var handle;
        var circleX;

        if (GameState.differentsHandle.getIndex(item) !== -1) {
            handle = GameState.differentsHandle;
            circleX = game.input.activePointer.x + GameState.differents.x;
        } else {
            handle = GameState.differentsHandleOrginal;
            circleX = game.input.activePointer.x;
        }

        GameState.differentsHandleOrginal.getAt(handle.getIndex(item)).kill();
        GameState.differentsHandle.getAt(handle.getIndex(item)).kill();

        this.circleDraw = circle.beginFill(item.color, GameState.differentStyle.transparent);
        this.circleDraw.drawCircle(circleX, game.input.activePointer.y, GameState.differentStyle.size);
        this.circleDraw.drawCircle(circleX - 495, game.input.activePointer.y, GameState.differentStyle.size); // 495 = level.imagesSize.w + level.imagesMargin.x // przesuniecie 

        GameState.circleGroup.add(this.circleDraw);
        GameState.score++;

        if (GameState.score === GameState.differentCount) {
            GameState.circleGroup.destroy();
            GameState.circleGroup.alpha = 0;
            GameState.endLevelGratulation();
        }

    },
    endLevelGratulation: function() {
        game.add.tween(GameState.layout).to({ alpha: 1 }, 400, Phaser.Easing.Linear.None, true)
            .onComplete.add(function() {
                GameState.endLevelGroup = game.add.group();
                GameState.endLevelGroup.alpha = 0;

                GameState.endLevelGroup.create(0, 0, 'endLevelBackground');

                GameState.gratulationText = GameState.endLevelGroup.create(game.world.centerX, game.world.centerY - 270, 'endLevelGratulation');
                GameState.gratulationText.anchor.setTo(0.5, 0.5);
                GameState.gratulationText.scale.setTo(0, 0);

                GameState.endLevelAgain = GameState.endLevelGroup.create(game.world.centerX - 70, game.world.centerY + 230, 'endLevelAgain');
                GameState.endLevelAgain.type = 'again';
                GameState.endLevelAgain.anchor.setTo(0.5, 0.5);
                GameState.endLevelAgain.scale.setTo(0, 0);

                GameState.endLevelNext = GameState.endLevelGroup.create(game.world.centerX + 70, game.world.centerY + 230, 'endLevelNext');
                GameState.endLevelNext.type = 'next';
                GameState.endLevelNext.anchor.setTo(0.5, 0.5);
                GameState.endLevelNext.scale.setTo(0, 0);

                game.add.tween(GameState.endLevelGroup).to({ alpha: 1 }, 400, Phaser.Easing.Linear.None, true)
                    .onComplete.add(function() {

                        game.add.tween(GameState.gratulationText.scale).to({ x: 1, y: 1 }, 350, Phaser.Easing.Linear.None, true);
                        game.add.tween(GameState.gratulationText).to({ x: game.world.centerX, y: game.world.centerY - 65 }, 350, Phaser.Easing.Linear.None, true)
                            .onComplete.add(function() {
                                game.add.tween(GameState.endLevelAgain.scale).to({ x: 1, y: 1 }, 350, Phaser.Easing.Linear.None, true);
                                game.add.tween(GameState.endLevelAgain).to({ x: game.world.centerX - 150, y: game.world.centerY + 185 }, 350, Phaser.Easing.Linear.None, true)
                                    .onComplete.add(function() {
                                        GameState.endLevelAgain.inputEnabled = true;
                                        GameState.endLevelAgain.input.useHandCursor = true;
                                        GameState.endLevelAgain.input.start(0, true);
                                    });
                                game.add.tween(GameState.endLevelNext.scale).to({ x: 1, y: 1 }, 350, Phaser.Easing.Linear.None, true);
                                game.add.tween(GameState.endLevelNext).to({ x: game.world.centerX + 150, y: game.world.centerY + 185 }, 350, Phaser.Easing.Linear.None, true)
                                    .onComplete.add(function() {
                                        GameState.endLevelNext.inputEnabled = true;
                                        GameState.endLevelNext.input.useHandCursor = true;
                                        GameState.endLevelNext.input.start(0, true);
                                    });
                            });

                        GameState.endLevelNext.events.onInputDown.add(GameState.endLevelClick);
                        GameState.endLevelNext.events.onInputUp.add(GameState.endLevelClick);

                        GameState.endLevelAgain.events.onInputDown.add(GameState.endLevelClick);
                        GameState.endLevelAgain.events.onInputUp.add(GameState.endLevelClick);

                    });
            }, this);
    },
    endLevelClick: function(item) {
        GameState.endLevelButtons.clicked = (GameState.endLevelButtons.clicked === false) ? true : false;
        if (GameState.endLevelButtons.enable) {
            game.add.tween(GameState.endLevelGroup).to({ alpha: 0 }, 200, Phaser.Easing.Linear.None, true)
                .onComplete.add(function() {
                    if (item.type === 'next') {
                        MenuState.clickedEnable = true;
                        game.state.start('MenuState');
                    } else {
                        GameState.endLevelButtons.enable = true;
                        game.state.start('GameState');
                    }
                });
            GameState.endLevelButtons.enable = false;
        }

    }
};