var LoadState = {
    preloadBar: { progress: null, text: null },

    handleIncorrectOrientation: function() {
        if (!game.device.desktop)
            document.getElementById("turn").style.display = "block";
    },

    handleCorrectOrientation: function() {
        if (!game.device.desktop)
            document.getElementById("turn").style.display = "none";
    },

    preload: function() {
        this.game.scale.scaleMode = Phaser.ScaleManager.USER_SCALE;
        this.game.scale.forceOrientation(true, false);
        this.game.scale.enterIncorrectOrientation.add(LoadState.handleIncorrectOrientation);
        this.game.scale.leaveIncorrectOrientation.add(LoadState.handleCorrectOrientation);

        this.game.load.image('background', 'assets/ekranLadowaniaTlo.png');
        this.game.load.image('preloadBackground', 'assets/preloadBackground.png');
        this.game.load.image('preload', 'assets/ekranLadowaniaPasek.png');
    },

    create: function() {
        game.stage.background = this.game.add.sprite(0, 0, 'background');
        game.scale.refresh();
        game.scale.setResizeCallback(function(context, scaleManager, bounds) {
            var scale = Math.max(window.innerWidth / 1388, window.innerHeight / 720);

            if (window.innerHeight < 720 * scale - 720 * scale * ((720 - 640) / 720) // 0.13043478 is (552 - 480) / 552 (non-logical height / overall height)
                ||
                window.innerWidth < 1388 * scale - 1388 * scale * ((1388 - 960) / 1388)) // 0.16666667 is (864 - 720) / 864 (non-logical width / overall width)
                scale = Math.min(window.innerWidth / (1388 - 1388 * ((1388 - 960) / 1388)), window.innerHeight / (720 - 720 * ((720 - 640) / 720)));

            game.scale.setUserScale(scale, scale);

            var gameWidth = 1388 * scale;
            var gameHeight = 720 * scale;

            game.canvas.style.left = parseInt(window.innerWidth / 2 - game.canvas.offsetWidth / 2) + "px";
            game.canvas.style.top = parseInt(window.innerHeight / 2 - game.canvas.offsetHeight / 2) + "px";
        });
        this.game.load.onFileComplete.add(LoadState.fileComplete, this);
        this.game.load.onLoadComplete.add(LoadState.loadComplete, this);

        this.preloadBar.text = game.add.text(game.world.centerX - 222, game.world.centerY - 150, 'Ładowanie gry 0%', {
            font: "48px Pacifico",
            stroke: '#ea6928',
            strokeThickness: '32',
            fill: "#ffffff",
            align: "center"
        });

        this.preloadBackground = game.add.sprite(game.world.centerX - 416.5, game.world.centerY - 32, 'preloadBackground');

        var bmd = game.make.bitmapData(1, 256);
        bmd.alphaMask('preload', 'preloadBackground');

        this.preloadBar.progress = game.add.image(game.world.centerX - 416.5, game.world.centerY - 32, bmd);

        this.start();
    },

    start: function() {
        this.game.load.image('startBackground', 'assets/ekranStartowy.png');
        this.game.load.image('menuBackground', 'assets/wyborPlanszy.png');
        this.game.load.image('wyjscieDoMenu1', 'assets/wyjscieDoMenu.png');
        this.game.load.image('wyjscieDoMenu2', 'assets/wyjscieDoMenuPoNajechaniu.png');
        this.game.load.image('informacja', 'assets/informacja.png');
        this.game.load.image('level1Tlo', 'assets/poziom6Tlo.png');
        this.game.load.image('level2Tlo', 'assets/poziom8Tlo.png');
        this.game.load.image('level3Tlo', 'assets/poziom10Tlo.png');
        this.game.load.image('level4Tlo', 'assets/poziom12Tlo.png');

        this.game.load.image('level1Curiosity', 'assets/ciekawostka1.png');
        this.game.load.image('level2Curiosity', 'assets/ciekawostka2.png');
        this.game.load.image('level3Curiosity', 'assets/ciekawostka3.png');
        this.game.load.image('level4Curiosity', 'assets/ciekawostka4.png');
        this.game.load.image('level5Curiosity', 'assets/ciekawostka5.png');
        this.game.load.image('level6Curiosity', 'assets/ciekawostka6.png');
        this.game.load.image('level7Curiosity', 'assets/ciekawostka7.png');
        this.game.load.image('level8Curiosity', 'assets/ciekawostka8.png');

        this.game.load.image('para1', 'assets/wybor61.png');
        this.game.load.image('para2', 'assets/wybor62.png');
        this.game.load.image('para3', 'assets/wybor81.png');
        this.game.load.image('para4', 'assets/wybor82.png');
        this.game.load.image('para5', 'assets/wybor101.png');
        this.game.load.image('para6', 'assets/wybor102.png');
        this.game.load.image('para7', 'assets/wybor121.png');
        this.game.load.image('para8', 'assets/wybor122.png');

        this.game.load.image('level1Image', 'assets/poziom6_1_1.png');
        this.game.load.image('level1ImageOrginal', 'assets/poziom6_1_2.png');
        this.game.load.image('level1Roznica0', 'assets/6_1_1.png');
        this.game.load.image('level1Roznica1', 'assets/6_1_2.png');
        this.game.load.image('level1Roznica2', 'assets/6_1_3.png');
        this.game.load.image('level1Roznica3', 'assets/6_1_4.png');
        this.game.load.image('level1Roznica4', 'assets/6_1_5.png');
        this.game.load.image('level1Roznica5', 'assets/6_1_6.png');

        this.game.load.image('level2Image', 'assets/poziom6_2_1.png');
        this.game.load.image('level2ImageOrginal', 'assets/poziom6_2_2.png');
        this.game.load.image('level2Roznica0', 'assets/6_2_1.png');
        this.game.load.image('level2Roznica1', 'assets/6_2_2.png');
        this.game.load.image('level2Roznica2', 'assets/6_2_3.png');
        this.game.load.image('level2Roznica3', 'assets/6_2_4.png');
        this.game.load.image('level2Roznica4', 'assets/6_2_5.png');
        this.game.load.image('level2Roznica5', 'assets/6_2_6.png');

        this.game.load.image('level3Image', 'assets/poziom8_1_1.png');
        this.game.load.image('level3ImageOrginal', 'assets/poziom8_1_2.png');
        this.game.load.image('level3Roznica0', 'assets/8_1_1.png');
        this.game.load.image('level3Roznica1', 'assets/8_1_2.png');
        this.game.load.image('level3Roznica2', 'assets/8_1_3.png');
        this.game.load.image('level3Roznica3', 'assets/8_1_4.png');
        this.game.load.image('level3Roznica4', 'assets/8_1_5.png');
        this.game.load.image('level3Roznica5', 'assets/8_1_6.png');
        this.game.load.image('level3Roznica6', 'assets/8_1_7.png');
        this.game.load.image('level3Roznica7', 'assets/8_1_8.png');

        this.game.load.image('level4Image', 'assets/poziom8_2_1.png');
        this.game.load.image('level4ImageOrginal', 'assets/poziom8_2_2.png');
        this.game.load.image('level4Roznica0', 'assets/8_2_1.png');
        this.game.load.image('level4Roznica1', 'assets/8_2_2.png');
        this.game.load.image('level4Roznica2', 'assets/8_2_3.png');
        this.game.load.image('level4Roznica3', 'assets/8_2_4.png');
        this.game.load.image('level4Roznica4', 'assets/8_2_5.png');
        this.game.load.image('level4Roznica5', 'assets/8_2_6.png');
        this.game.load.image('level4Roznica6', 'assets/8_2_7.png');
        this.game.load.image('level4Roznica7', 'assets/8_2_8.png');

        this.game.load.image('level5Image', 'assets/poziom10_1_1.png');
        this.game.load.image('level5ImageOrginal', 'assets/poziom10_1_2.png');
        this.game.load.image('level5Roznica0', 'assets/10_1_1.png');
        this.game.load.image('level5Roznica1', 'assets/10_1_2.png');
        this.game.load.image('level5Roznica2', 'assets/10_1_3.png');
        this.game.load.image('level5Roznica3', 'assets/10_1_4.png');
        this.game.load.image('level5Roznica4', 'assets/10_1_5.png');
        this.game.load.image('level5Roznica5', 'assets/10_1_6.png');
        this.game.load.image('level5Roznica6', 'assets/10_1_7.png');
        this.game.load.image('level5Roznica7', 'assets/10_1_8.png');
        this.game.load.image('level5Roznica8', 'assets/10_1_9.png');
        this.game.load.image('level5Roznica9', 'assets/10_1_10.png');

        this.game.load.image('level6Image', 'assets/poziom10_2_1.png');
        this.game.load.image('level6ImageOrginal', 'assets/poziom10_2_2.png');
        this.game.load.image('level6Roznica0', 'assets/10_2_1.png');
        this.game.load.image('level6Roznica1', 'assets/10_2_2.png');
        this.game.load.image('level6Roznica2', 'assets/10_2_3.png');
        this.game.load.image('level6Roznica3', 'assets/10_2_4.png');
        this.game.load.image('level6Roznica4', 'assets/10_2_5.png');
        this.game.load.image('level6Roznica5', 'assets/10_2_6.png');
        this.game.load.image('level6Roznica6', 'assets/10_2_7.png');
        this.game.load.image('level6Roznica7', 'assets/10_2_8.png');
        this.game.load.image('level6Roznica8', 'assets/10_2_9.png');
        this.game.load.image('level6Roznica9', 'assets/10_2_10.png');

        this.game.load.image('level7Image', 'assets/poziom12_1_1.png');
        this.game.load.image('level7ImageOrginal', 'assets/poziom12_1_2.png');
        this.game.load.image('level7Roznica0', 'assets/12_1_1.png');
        this.game.load.image('level7Roznica1', 'assets/12_1_2.png');
        this.game.load.image('level7Roznica2', 'assets/12_1_3.png');
        this.game.load.image('level7Roznica3', 'assets/12_1_4.png');
        this.game.load.image('level7Roznica4', 'assets/12_1_5.png');
        this.game.load.image('level7Roznica5', 'assets/12_1_6.png');
        this.game.load.image('level7Roznica6', 'assets/12_1_7.png');
        this.game.load.image('level7Roznica7', 'assets/12_1_8.png');
        this.game.load.image('level7Roznica8', 'assets/12_1_9.png');
        this.game.load.image('level7Roznica9', 'assets/12_1_10.png');
        this.game.load.image('level7Roznica10', 'assets/12_1_11.png');
        this.game.load.image('level7Roznica11', 'assets/12_1_12.png');

        this.game.load.image('level8Image', 'assets/poziom12_2_1.png');
        this.game.load.image('level8ImageOrginal', 'assets/poziom12_2_2.png');
        this.game.load.image('level8Roznica0', 'assets/12_2_1.png');
        this.game.load.image('level8Roznica1', 'assets/12_2_2.png');
        this.game.load.image('level8Roznica2', 'assets/12_2_3.png');
        this.game.load.image('level8Roznica3', 'assets/12_2_4.png');
        this.game.load.image('level8Roznica4', 'assets/12_2_5.png');
        this.game.load.image('level8Roznica5', 'assets/12_2_6.png');
        this.game.load.image('level8Roznica6', 'assets/12_2_7.png');
        this.game.load.image('level8Roznica7', 'assets/12_2_8.png');
        this.game.load.image('level8Roznica8', 'assets/12_2_9.png');
        this.game.load.image('level8Roznica9', 'assets/12_2_10.png');
        this.game.load.image('level8Roznica10', 'assets/12_2_11.png');
        this.game.load.image('level8Roznica11', 'assets/12_2_12.png');


        this.game.load.image('przyciskDown', 'assets/strzalkaDol.png');
        this.game.load.image('przyciskUp', 'assets/strzalkaGora.png');

        this.game.load.image('endLevelBackground', 'assets/gratulacjeTlo.png');
        this.game.load.image('endLevelGratulation', 'assets/gratulacjeChmurka.png');
        this.game.load.image('endLevelNext', 'assets/gratulacjeWybierzPlansze.png');
        this.game.load.image('endLevelAgain', 'assets/gratulacjePowtorz.png');
        this.game.load.start();
    },

    fileComplete: function(progress, cacheKey, success, totalLoaded, totalFiles) {
        var bmd = game.make.bitmapData((progress * 833 / 100), 256);
        bmd.alphaMask('preload', 'preloadBackground');
        LoadState.preloadBar.progress = game.add.image(game.world.centerX - 416.5, game.world.centerY - 32, bmd);
        LoadState.preloadBar.text.setText('Ładowanie gry ' + progress + '%');
    },

    loadComplete: function() {
        this.game.state.start('StartState');
    }
};